'FFSubmenu=Effekte
'FFName=Triptychon+

' ********************************************************************
' Triptychon_Plus.vbs (Script fr FixFoto)
' von Harald Maeckler, Dsseldorf 2010 - 2106
'
' Version 1.04 vom 14.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.03 vom 29.06.2014	- Update-Funktion hinzu
'								- bei Farbwechsel jetzt automatisch Vorschau (ab FF 3.30)
'								- Bedienoberflche vereinfacht
'								- Tooltips hinzugefgt
' Version 1.02 vom 12.08.2010	- Option 'Bildteile speichern' hinzu
'								- Befehlssymbole kleiner und grer gendert
' Version 1.01 vom 02.08.2010	- mit und ohne Versatz
' Version 1.00 vom 26.07.2010	- Betaversion

'** Start Kurzbeschreibung *******************************************
' Triptychon+ / Version 1.04
' ================
'
' Das geladene Bild wird in drei Teile geteilt. Dabei ist ber eine Vorschau einstellbar:
' 	- Fugenbreite in Promille der Bildbreite
' 	- FugenFarbe
' 	- Fugen mit oder ohne Schattierung, mit oder ohne Versatz
' 	- Breite des Mittelteils in Promille der Bildbreite
' 	  wobei die Teile links und rechts immer der halben Restbreite entsprechen
' Mit 'Start' wird das Triptychon erzeugt und angezeigt.
'
' Ist bei 'Start' die Option 'Bildteile speichern' aktiviert, werden die drei Bildteile
' unter gleichem Namen ergnzt um den Anhang
'	_TPTL	fr Triptychon linker Teil
'	_TPTM	fr Triptychon Mittelteil
'	_TPTR	fr Triptychon rechter Teil
' abgespeichert mit der in den FF-Einstellungen festgelegten Qualitt.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine Lsch-
' routine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das zugehrige
' zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten, davon eine
' Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nacheinander die
' Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatzdateien gelscht.
' Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit allen
' Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.04"
const SkriptURL = "http://www.ffsf.de/resources/triptychon.170/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim Einmal : Einmal = false
Dim OrgBreite,OrgHoehe,OrgInkrement,Breite,Hoehe
Dim Fugenbreite,Color,Farbe,RGB
Dim boolMS,boolMV
Dim Mittelteil,BTspeichern

const MaxLaenge = 400
Dim Inkrement : Inkrement = 2 / MaxLaenge * 1000

Dim TempFile,TempFileOrg,TempFileKlein

const RegSchluessel = "FF_Triptychon_Plus"					'Registryschlssel
const SkriptName = "Triptychon_Plus.vbs"					'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS													'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Dim WshShell
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill
SkriptKill = false	'bei true wird mit Beenden des Skripts dieses komplett mit Registrydaten gelscht !!!
'---------------------------------------------------------------------
call Main
'---------------------------------------------------------------------
Sub Main

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	OrgBreite = FF_GetImageWidth()	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if OrgBreite = 0 then									'Kontrolle ob ein Bild geladen ist
	msgbox "Kein Bild geladen!",vbCritical,"Abbruch"
	exit sub
end if

OrgHoehe=FF_GetImageHeight()	'Originalhhe

if OrgBreite < OrgHoehe then
	msgbox "Das Bild muss querformatig bzw. quadratisch sein!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Triptychon+ **
FF_AddDialog "Triptychon+",279,295
FF_AddControl "Triptychon+","Fugenbreite","GROUP",5,5,90,35
FF_AddControl "Triptychon+","> <","BUTTON",14,14,25,10
FF_AddControl "Triptychon+",">> <<","BUTTON",14,25,25,10
FF_AddControl "Triptychon+","< >","BUTTON",61,14,25,10
FF_AddControl "Triptychon+","<< >>","BUTTON",61,25,25,10
FF_AddControl "Triptychon+","SollB","SLEDIT",42,16,16,10
FF_SetControlStyle "Triptychon+","SollB",2049
FF_AddControl "Triptychon+","","STATIC",40,26,20,10
FF_SetControlStyle "Triptychon+","",1
FF_AddControl "Triptychon+","Fugeneinstellungen","GROUP",105,5,170,35
FF_AddControl "Triptychon+","Fugenfarbe:","STATIC",113,20,33,10
FF_AddControl "Triptychon+","LinCol","COLOR",150,20,33,10
FF_AddControl "Triptychon+","boolMS","BOOL",207,15,8,8
FF_SetControlStyle "Triptychon+","boolMS",16384
FF_AddControl "Triptychon+","mit Schatten","STATIC",220,14,33,10
FF_AddControl "Triptychon+","boolMV","BOOL",207,26,8,8
FF_SetControlStyle "Triptychon+","boolMV",16384
FF_AddControl "Triptychon+","mit Versatz","STATIC",220,25,33,10
FF_AddControl "Triptychon+","VBild","IMAGE",5,45,270,190
FF_AddControl "Triptychon+","Aufteilung","GROUP",5,240,270,35
FF_AddControl "Triptychon+","Breite des Mittelteils","STATIC",115,244,48,10
FF_SetControlStyle "Triptychon+","Breite des Mittelteils",1
FF_AddControl "Triptychon+","SollM","SLEDIT",131,254,16,10
FF_SetControlStyle "Triptychon+","SollM",2049
FF_AddControl "Triptychon+","|","STATIC",132,264,13,10
FF_SetControlStyle "Triptychon+","|",1
FF_AddControl "Triptychon+","> <|","BUTTON",37,254,25,10
FF_AddControl "Triptychon+",">> <<|","BUTTON",68,254,25,10
FF_AddControl "Triptychon+",">>> <<<|","BUTTON",99,254,25,10
FF_AddControl "Triptychon+","<<< >>>|","BUTTON",153,254,25,10
FF_AddControl "Triptychon+","<< >>|","BUTTON",186,254,25,10
FF_AddControl "Triptychon+","< >|","BUTTON",218,254,25,10
FF_AddControl "Triptychon+","?","BUTTON",12,280,11,11
FF_AddControl "Triptychon+","Abbrechen","BUTTON",104,280,33,11
FF_AddControl "Triptychon+","BTspeichern","BOOL",154,282,8,8
FF_AddControl "Triptychon+","Bildteile speichern","STATIC",165,281,45,10
FF_AddControl "Triptychon+","Start","BUTTON",218,280,33,11
FF_AddControl "Triptychon+","&d","BUTTON",0,0,1,1
FF_AddControl "Triptychon+","|","STATIC",27,280,24,11
FF_SetControlStyle "Triptychon+","|",1
FF_AddControl "Triptychon+","Update","BUTTON",54,280,33,11
'** End Dialog Triptychon+ **

'Original temporr speichern
TempFileOrg = FF_GetScriptPath & "\tempOrg.bmp"
FF_SaveImage TempFileOrg,0
FF_PushImage()

call RegistryLesen

'Bild verkleinern
FF_HQScale MaxLaenge,MaxLaenge, true
'Verkleinerung temporr speichern
TempFileKlein = FF_GetScriptPath & "\tempKlein.bmp"
FF_SaveImage TempFileKlein,0
Breite=FF_GetImageWidth()		'Abmessungen der Verkleinerung
Hoehe =FF_GetImageHeight()

FF_PushImage()
call Vorschau

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Triptychon+","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Triptychon+","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip "Triptychon+","Abbrechen", "" &_
						 "Das Skript vorzeitig beenden"
	FF_SetControlTooltip "Triptychon+","BTspeichern", "" &_
						 "Bei Erzeugung des Triptychons werden" & vbNewLine &_
						 "die drei Bildteile abgespeichert." & vbNewLine &_
						 "Nheres dazu ==> Kurzbeschreibung (?)"
	FF_SetControlTooltip "Triptychon+","Start", "" &_
						 "Erzeugung des Triptychons und ggf." & vbNewLine &_
						 "Abspeicherung der drei Bildteile"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Triptychon+","&d"
FF_SetDialogTimer "Triptychon+", 100

do
	Select Case FF_ShowDialog ("Triptychon+")
	Case "TIMER"
		FF_SetControl "Triptychon+" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Triptychon+", 0
	Case "&d"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "> <"
		call WerteAuslesen
		if Fugenbreite > Inkrement then
			Fugenbreite = Fugenbreite - Inkrement
			FF_SetControl "Triptychon+","SollB",Fugenbreite
			Call Vorschau
		end if
	Case "< >"
		call WerteAuslesen
		if Fugenbreite < 200 then
			Fugenbreite = Fugenbreite + Inkrement
			FF_SetControl "Triptychon+","SollB",Fugenbreite
			Call Vorschau
		end if
	Case ">> <<"
		call WerteAuslesen
		if Fugenbreite > (3 * Inkrement) then
			Fugenbreite = Fugenbreite - 3 * Inkrement
			FF_SetControl "Triptychon+","SollB",Fugenbreite
			Call Vorschau
		end if
	Case "<< >>"
		call WerteAuslesen
		if Fugenbreite < 200 then
			Fugenbreite = Fugenbreite + 3 * Inkrement
			FF_SetControl "Triptychon+","SollB",Fugenbreite
			Call Vorschau
		end if
	Case "boolMS"
		call WerteAuslesen
		call Vorschau
	Case "boolMV"
		call WerteAuslesen
		call Vorschau
	Case "> <|"
		call WerteAuslesen
		if Mittelteil > (Fugenbreite * 2 + Inkrement) then
			Mittelteil = Mittelteil - Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case ">> <<|"
		call WerteAuslesen
		if Mittelteil > (Fugenbreite * 2 + 3 * Inkrement) then
			Mittelteil = Mittelteil - 3 * Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case ">>> <<<|"
		call WerteAuslesen
		if Mittelteil > (Fugenbreite * 2 + 12 * Inkrement) then
			Mittelteil = Mittelteil - 12 * Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case "< >|"
		call WerteAuslesen
		if (Mittelteil + Fugenbreite * 2 + Inkrement) < 1000 then
			Mittelteil = Mittelteil + Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case "<< >>|"
		call WerteAuslesen
		if (Mittelteil + Fugenbreite * 2 + 3 * Inkrement) < 1000 then
			Mittelteil = Mittelteil + 3 * Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case "<<< >>>|"
		call WerteAuslesen
		if (Mittelteil + Fugenbreite * 2 + 12 * Inkrement) < 1000 then
			Mittelteil = Mittelteil + 12 * Inkrement
			FF_SetControl "Triptychon+","SollM",Mittelteil
			Call Vorschau
		end if
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "VBild","LinCol"
		call WerteAuslesen
		call Vorschau
	Case "CANCEL","Abbrechen"
		exit do
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		call WerteAuslesen
		FF_PopImage
		FF_PopImage
		TempFile = TempFileOrg
		
		if boolMS = 1 then
			if boolMV then
				call Schattenbildung_mV (OrgBreite,OrgHoehe,Fugenbreite)
				call OriginalMix_mV (OrgBreite,OrgHoehe)
			else
				call Schattenbildung_oV (OrgBreite,OrgHoehe,Fugenbreite)
				call OriginalMix_oV (OrgBreite,OrgHoehe)
			end if
		else
			if boolMV then
				call Umrandung_mV (OrgBreite,OrgHoehe)
			else
				call Umrandung_oV (OrgBreite,OrgHoehe)
			end if
		end if
		
		if BTspeichern = 1 then 
			if boolMV then
				call Abspeichern_mV (OrgBreite,OrgHoehe)
			else
				call Abspeichern_oV (OrgBreite,OrgHoehe)
			end if
		end if
		
		FF_Reload
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Triptychon+")

if objFS.FileExists(TempFile) then	'TempFile lschen
	objFS.DeleteFile TempFile,true
end if

if SkriptKill then call KillSkript

End Sub
'---------------------------------------------------------------------
Sub WerteAuslesen

'Fugenbreite
Fugenbreite = FF_GetControl("Triptychon+","SollB") *1

'Fugeneinstellungen
Color = FF_GetControl("Triptychon+","LinCol")
Farbe = split(Color," ")
RGB = Farbe(0) + Farbe(1) * (2^8) + Farbe(2) * (2^16)

boolMS = FF_GetControl("Triptychon+","boolMS")
boolMV = FF_GetControl("Triptychon+","boolMV")

'Aufteilung
Mittelteil = FF_GetControl("Triptychon+","SollM") *1

'Bildteile speichern
BTspeichern = FF_GetControl("Triptychon+","BTspeichern") 

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel
Dim Liste,Array,element,OK

'### Werte auslesen
'Fugenbreite
Fugenbreite = FF_GetProfile (RegSchluessel,"Fugenbreite")
if Fugenbreite = "" then Fugenbreite = 20

'Fugeneinstellungen
Color = FF_GetProfile (RegSchluessel,"Color")
if Color = "" then Color = "000 000 000"
Farbe = split(Color," ")
RGB = Farbe(0) + Farbe(1) * (2^8) + Farbe(2) * (2^16)

boolMS = FF_GetProfile (RegSchluessel,"boolMS")
if boolMS = "" then boolMS = 0
boolMV = FF_GetProfile (RegSchluessel,"boolMV")
if boolMV = "" then boolMV = 0

'Aufteilung
Mittelteil = FF_GetProfile (RegSchluessel,"Mittelteil")
if Mittelteil = "" then Mittelteil = 600

'Bildteile speichern
BTspeichern = FF_GetProfile (RegSchluessel,"BTspeichern")
if BTspeichern = "" then BTspeichern = 0

'### Werte eintragen
'Fugenbreite
FF_SetControl "Triptychon+","SollB",Fugenbreite

'Fugeneinstellungen
FF_SetControl "Triptychon+","LinCol",Color
FF_SetControl "Triptychon+","boolMS",boolMS
FF_SetControl "Triptychon+","boolMV",boolMV

'Aufteilung
FF_SetControl "Triptychon+","SollM",Mittelteil

'Bildteile speichern
FF_SetControl "Triptychon+","BTspeichern",BTspeichern

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'Werte auslesen
call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Fugenbreite",Fugenbreite
FF_WriteProfile RegSchluessel,"Color",Color
FF_WriteProfile RegSchluessel,"boolMS",boolMS
FF_WriteProfile RegSchluessel,"boolMV",boolMV
FF_WriteProfile RegSchluessel,"Mittelteil",Mittelteil
FF_WriteProfile RegSchluessel,"BTspeichern",BTspeichern

End Sub
'---------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'-------------------------------------------------------------------------
Sub Vorschau

TempFile = TempFileKlein

if boolMS = 1 then
	if boolMV then
		call Schattenbildung_mV (Breite,Hoehe,Inkrement)
		call Schattenbildung_mV (Breite,Hoehe,Fugenbreite)
		call OriginalMix_mV (Breite,Hoehe)
	else
		call Schattenbildung_oV (Breite,Hoehe,Inkrement)
		call Schattenbildung_oV (Breite,Hoehe,Fugenbreite)
		call OriginalMix_oV (Breite,Hoehe)
	end if
else
	if boolMV then
		call Umrandung_mV (Breite,Hoehe)
	else
		call Umrandung_oV (Breite,Hoehe)
	end if
end if
			
FF_SetControl "Triptychon+","VBild",0

End Sub
'------------------------------------------------------------------------
Sub Umrandung_oV (B,H)
'Umrandung ohne Versatz

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim xstart,ystart,xend,yend

FF_LoadImage TempFile

ystart = 0 : yend = H	
	xstart = (B - B / 1000 * Mittelteil) / 2
	xend = xstart
	FF_Line xstart,ystart,xend,yend,RGB,LinSt

	xstart = B - xStart
	xend = xstart
	FF_Line xstart,ystart,xend,yend,RGB,LinSt

FF_ExtendCanvas LinSt,LinSt,LinSt,LinSt,Farbe(0),Farbe(1),Farbe(2)

End Sub
'------------------------------------------------------------------------
Sub Umrandung_mV (B,H)
'Umrandung mit Versatz

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim x,y,Kachelbreite,Mittenbreite

FF_NewImage B + 2 * LinSt,H,RGB
FF_PushImage

y = 0
Mittenbreite = B / 1000 * Mittelteil + LinSt
Kachelbreite = (B - Mittenbreite) / 2

'Kachel 1
x = 0
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x,y,Kachelbreite,H,255	'Mischen
'Kachel 2
x = Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Mittenbreite,H			'Ausschneiden
	FF_MixImage x + LinSt,y,Mittenbreite,H,255	'Mischen
'Kachel 3
x = B - Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x + 2 * Linst,y,Kachelbreite,H,255	'Mischen	

FF_PopImage
FF_ExtendCanvas LinSt,LinSt,LinSt,LinSt,Farbe(0),Farbe(1),Farbe(2)

End Sub
'------------------------------------------------------------------------
Sub Schattenbildung_oV (B,H,F)
'Schattenbildung ohne Versatz

Dim yo,xo,i,xs,ys,Transparenz

Dim LinSt
LinSt = B / 1000 * F

Dim x,y,Kachelbreite,Mittenbreite

FF_NewImage B + LinSt,H + LinSt,RGB

yo = 0
Mittenbreite = B / 1000 * Mittelteil - Linst
Kachelbreite = (B - Mittenbreite) / 2 - LinSt

'Kachel 1
xo = 0
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+H,Transparenz
		next
'Kachel 2
xo = Kachelbreite + LinSt
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Mittenbreite,ys+H,Transparenz
		next
'Kachel 3
xo = B  - Kachelbreite
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+H,Transparenz
		next

FF_AdjustRGB 0,0,0
FF_PushImage

End Sub
'------------------------------------------------------------------------
Sub OriginalMix_oV (B,H)

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim x,y,Kachelbreite,Mittenbreite

y = 0
Mittenbreite = B / 1000 * Mittelteil
Kachelbreite = (B - Mittenbreite) / 2 - LinSt / 2

'Kachel 1
x = 0
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x,y,Kachelbreite,H,255	'Mischen
'Kachel 2
x = Kachelbreite + LinSt
	FF_LoadImage TempFile
	FF_Crop x,y,Mittenbreite-LinSt,H			'Ausschneiden
	FF_MixImage x,y,Mittenbreite-LinSt,H,255	'Mischen
'Kachel 3
x = B - Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x,y,Kachelbreite,H,255	'Mischen	

FF_PopImage
FF_ExtendCanvas LinSt,0,LinSt,0,Farbe(0),Farbe(1),Farbe(2)

End Sub
'------------------------------------------------------------------------
Sub Schattenbildung_mV (B,H,F)
'Schattenbildung mit Versatz

Dim yo,xo,i,xs,ys,Transparenz

Dim LinSt
LinSt = B / 1000 * F

Dim Kachelbreite,Mittenbreite

FF_NewImage B + 3 * LinSt,H + LinSt,RGB

yo = 0
Mittenbreite = B / 1000 * Mittelteil + LinSt
Kachelbreite = (B - Mittenbreite) / 2

'Kachel 1
xo = 0
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+H,Transparenz
		next
'Kachel 2
xo = Kachelbreite + LinSt
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Mittenbreite,ys+H,Transparenz
		next
'Kachel 3
xo = B + 2 * LinSt - Kachelbreite
		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = i + xo
			ys = i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+H,Transparenz
		next

FF_AdjustRGB 0,0,0
FF_PushImage

End Sub
'------------------------------------------------------------------------
Sub OriginalMix_mV (B,H)
'Originalbild mixen mit Schattenbild mit Versatz

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim x,y,Kachelbreite,Mittenbreite

y = 0
Mittenbreite = B / 1000 * Mittelteil + LinSt
Kachelbreite = (B - Mittenbreite) / 2

'Kachel 1
x = 0
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x,y,Kachelbreite,H,255	'Mischen
'Kachel 2
x = Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Mittenbreite,H			'Ausschneiden
	FF_MixImage x + LinSt,y,Mittenbreite,H,255	'Mischen
'Kachel 3
x = B - Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_MixImage x + 2 * Linst,y,Kachelbreite,H,255	'Mischen	

FF_PopImage
FF_ExtendCanvas LinSt,0,LinSt,0,Farbe(0),Farbe(1),Farbe(2)

End Sub
'------------------------------------------------------------------------
Sub Abspeichern_mV (B,H)

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim x,y,Kachelbreite,Mittenbreite,Bild,Name,Ext,Pos

Bild = FF_GetImageName(-1)
Pos = InStrRev(Bild,".")
if Pos = 0 then
	magbox "Der Bildname kann nicht ermittelt werden." & vbNewLine & _
		   "Es erfolgt keine Abspeicherung der drei Bildteile!",vbExclamation,"Abbruch"
	exit sub
else
	Name = left(Bild,Pos-1)
	Ext = mid(Bild,Pos)
end if

FF_PushImage
FF_LoadImage TempFile

y = 0
Mittenbreite = B / 1000 * Mittelteil + LinSt
Kachelbreite = (B - Mittenbreite) / 2

'Kachel 1
x = 0
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_SaveImage Name & "_TPTL" & Ext,0
'Kachel 2
x = Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Mittenbreite,H			'Ausschneiden
	FF_SaveImage Name & "_TPTM" & Ext,0
'Kachel 3
x = B - Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_SaveImage Name & "_TPTR" & Ext,0
FF_PopImage

End Sub
'------------------------------------------------------------------------
Sub Abspeichern_oV (B,H)

Dim LinSt
LinSt = B / 1000 * Fugenbreite

Dim x,y,Kachelbreite,Mittenbreite,Bild,Name,Ext,Pos

Bild = FF_GetImageName(-1)
Pos = InStrRev(Bild,".")
if Pos = 0 then
	magbox "Der Bildname kann nicht ermittelt werden." & vbNewLine & _
		   "Es erfolgt keine Abspeicherung der drei Bildteile!",vbExclamation,"Abbruch"
	exit sub
else
	Name = left(Bild,Pos-1)
	Ext = mid(Bild,Pos)
end if

FF_PushImage
FF_LoadImage TempFile

y = 0
Mittenbreite = B / 1000 * Mittelteil
Kachelbreite = (B - Mittenbreite) / 2 - LinSt / 2

'Kachel 1
x = 0
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_SaveImage Name & "_TPTL" & Ext,0
'Kachel 2
x = Kachelbreite + LinSt
	FF_LoadImage TempFile
	FF_Crop x,y,Mittenbreite-LinSt,H	'Ausschneiden
	FF_SaveImage Name & "_TPTM" & Ext,0
'Kachel 3
x = B - Kachelbreite
	FF_LoadImage TempFile
	FF_Crop x,y,Kachelbreite,H			'Ausschneiden
	FF_SaveImage Name & "_TPTR" & Ext,0

FF_PopImage

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
